/*
 *
 * XFT35-04_Ref_Design
 * Copyright (c) 2019 SSS
 *
*/

#include "xparameters.h"
#include "xil_cache.h"
#include "xil_io.h"
#include "xil_printf.h"
#include "backward_IP.h"

/* Define delay length */
#define DELAY 10

/* Define the base memory address of the FLC_BW_H IP core */
#define BW_BASE XPAR_BACKWARD_IP_0_S00_AXI_BASEADDR

int main(){

	int x, phi, y, bw, alpha;
	int i, i1, i2, np;
	double inc;

	np = 40;
	inc = 1023./np;

    Xil_ICacheEnable();
    Xil_DCacheEnable();

	//xil_printf("Starting...\r\n");
	
	y = 512;
	for (i1=0; i1<=np; i1+=1){
		x = i1*inc;
		for (i2=0; i2<=np; i2+=1){
			phi = i2* inc;
			// write input values to AXI registers
			BACKWARD_IP_mWriteReg(BW_BASE, 0, x);
			BACKWARD_IP_mWriteReg(BW_BASE, 4, phi);
			BACKWARD_IP_mWriteReg(BW_BASE, 8, y);
			// Wait for completing the inference process
			for (i=0; i<DELAY; i++);
			// read output data from AXI registers
			bw = BACKWARD_IP_mReadReg(BW_BASE, 12);
			alpha = BACKWARD_IP_mReadReg(BW_BASE, 16);
			// Print values of x, phi, y, bw, alpha to standard output
			xil_printf("%d\t%d\t%d\t%d\t%d\r\n", x, phi, y, bw, alpha);
		}
		xil_printf("\r\n");
	}

	//xil_printf("\r\nfinished!....\r\n");

    Xil_ICacheDisable();
    Xil_DCacheDisable();

    return 0;
}


